# ====================================================================
# Copyright (c) 1999 GlobeCom GCAB AB.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer. 
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#
# 3. All advertising materials mentioning features or use of this
#    software must display the following acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# 4. The names "GlobeCom Jukebox" and "GlobeCom" must not be used to
#    endorse or promote products derived from this software without
#    prior written permission. For written permission, please contact
#    hpj@globecom.net.
#
# 5. Products derived from this software may not be called "GlobeCom
#    Jukebox" nor may "GlobeCom" appear in their names without prior written
#    permission of the GlobeCom GCAB AB.
#
# 6. Redistributions of any form whatsoever must retain the following
#    acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# THIS SOFTWARE IS PROVIDED BY GLOBECOM GCAB AB ``AS IS'' AND ANY
# EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL GLOBECOM GCAB AB OR
# ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
# ====================================================================

use defsjukebox; # Get the settings entered by the user during configuration

exit 1
    if (!$TARGETBASE);

exit 0
    if (fork);

$0="ripd.pl";

use POSIX ":sys_wait_h";
use DBI;
eval 'no warnings;'; # Only works in PERL 5.6

my $dbh=DBI->connect("dbi:mysql:database=$DBNAME",$DBUSER,$DBPASS) || die;

$|=1;

system("renice 10 $$");

sub fetchsetting {
    my $res=$dbh->prepare("select value from settings where name = ?");
    $res->execute($_[0]);
    my $ret;
    ($ret)=$res->fetchrow_array();
    return $ret;
}

sub fetchpersonalsetting {
    my $res=$dbh->prepare("select value from usersetting where name = ? and user = ?");
    $res->execute(@_);
    my $ret;
    if (!(($ret)=$res->fetchrow_array())) {
	return fetchsetting($_[0]);
    }
    return $ret;
}

my $upload=fetchsetting("INCOMING");
my $UPLOAD;
if ($upload) {
    $UPLOAD=$upload;
} else  {
    $UPLOAD=$TARGETBASE."/incoming/";
}
$UPLOAD.="/"
    if ($UPLOAD!~/\/$/);

my $unauthpri=fetchsetting("UNAUTHPRI")+1;

my %transforms;

my $res=$dbh->prepare("select fromid,toid from transformations where priority >= 0") || die;
$res->execute();
while(my ($from,$to)=$res->fetchrow_array) {
    $transforms{$from}=$to;
}
undef $res;

$dbh->do("update ripqueue set status = 0 where status >= 0") || die;

my $maxper=fetchsetting("RIPMAXPER");
my $maxtotal=fetchsetting("RIPTOTAL");

my %converters;
my %curconv;
my $total=0;

sub reaper {
    my $child=waitpid(-1,&WNOHANG);

    if (exists $converters{$child}) {
	my $cf=$converters{$child};
	$curconv{$cf}--;
	$total--;
	delete $converters{$child};
    }
    $SIG{CHLD}=\&reaper;
}

my $normreap=$SIG{CHLD};
$SIG{CHLD}=\&reaper;

my $sel=$dbh->prepare("select a.id,a.songid,a.fromid,a.toid,a.artist,a.title,a.album,".
		      "a.file,b.program,a.user,a.trackno,c.volid,abs(b.priority) as c ".
		      "from ripqueue a, transformations b left join songs c on a.songid = c.id ".
		      "where a.fromid like b.fromid and a.toid like b.toid and a.status = 0 ".
		      "order by c,a.id") || die;

my $volmnt=$dbh->prepare("select mounted from volumes where id = ?");

for (;;) {
    $sel->execute();
    my $num=0;
    while(my ($id,$songid,$from,$to,$artist,$title,$album,$file,$program,$user,$trackno,$volid)=$sel->fetchrow_array) {
	my $cf=$from."_".$to;
	if (!$curconv{$cf}) {
	    $curconv{$cf}=0;
	}

	if ($volid) {
	    $volmnt->execute($volid);
	    my ($mnt)=$volmnt->fetchrow_array;
	    $file="$mnt/$file";
	}

	if ($curconv{$cf}<$maxper&&$total<$maxtotal) {
	    $num++;
	    my $pid;
	    if ($pid=fork) {
		$converters{$pid}=$cf;
		$curconv{$cf}++;
		$total++;
	    } else {
		$SIG{CHLD}=$normreap;
		my $dbc=DBI->connect("dbi:mysql:database=$DBNAME",$DBUSER,$DBPASS) || die;
		my ($art,$tit,$newfile);
		if ($file=~/^[0-9]+$/||$file=~/:\/\//) {
		    ($art=$artist)=~s/[^a-z0-9]+/_/ig;
		    ($tit=$title)=~s/[^a-z0-9]+/_/ig;
		    $newfile=$UPLOAD."$art-$tit.$to";
		} else {
		    ($newfile=$file)=~s/\.[^\.]+$/\.$to/;
		    $newfile.=".$to"
			if ($newfile eq $file);
		}
		while(-f $newfile) {
		    $newfile=~s/(?:(\.)(\d+))?(\.[^\.]+)$/do {
			my $num=$2+1;
			".$num$3";
		    }/e;
		}
		$dbc->do("update ripqueue set status = 100 where id = $id") || die;
		
		if ($program!~/^\//) {
		    $program="$JUKEBOXBIN/$program";
		}
		print "Converting $file to format $to using $program\n";
		open(ENCODE,"-|") || do {
		    open(STDERR,">&STDOUT");
		    exec $program,$id,$file,$newfile;
		    die "Couldn't exec file";
		};
		undef $newfile;
		my $log="";
		while(<ENCODE>) {
		    $log.=$_;
		    $log=substr($log,-1000);
		    chomp;
		    if ($_=~/^([0-9]+)%$/) {
			$dbc->do("update ripqueue set status = $1 where id = $id")
			    if ($1>0&&$1<100);
		    } else {
			$newfile=$_;
		    }
		}
		
		if (!(close ENCODE)) {
		    my $exit=($?>>8);
		    my $signal=($?&0xff);
		    $log.="Conversion failed (Exit code $exit, signal $signal)\n";
		    my $ref=$dbc->prepare("update ripqueue set status = -1, log = ? where id = ?") || die;
		    $ref->execute($log,$id) || die;
		} elsif ($newfile) {
		    print "Conversion successfull\n";
		    if ($songid<=0) {
			my $sth=$dbc->prepare("insert into songs (artist,title,volume,file,played,voted,toplist,lastplayed,entered,format,user,trackno) ".
					 "values(?,?,?,?,0,0,0,now(),now(),?,?,?)") || die;
			$sth->execute($artist,$title,$album,$newfile,$to,$user,$trackno);

			my $progid=-$songid;
			$songid=$sth->{'mysql_insertid'};
			if ($progid) {
			    $dbc->do("insert into programmember values (0,$progid,$songid)");
			}
			if ($user) {
			    my $group=fetchpersonalsetting('AUTOADD',$user);
			    if ($group) {
				my $ftc=$dbc->prepare("select id from groups where name = ?");
				$ftc->execute($group);
				my $gid;
				if (($gid)=$ftc->fetchrow_array) {
				    $dbc->do("insert into groupmember values ($id,$songid)");
				}
			    }
			}
		    } elsif ($songid>0) {
			my $res=$dbc->prepare("update songs set file = ?, format = ? where id = ?");
			$res->execute($newfile,$to,$songid);
		    }
		    if ($songid>0) {
			my $ripinsert=fetchpersonalsetting("RIPINSERT",$user);
			if ($ripinsert) {
			    my $privatequeue=fetchpersonalsetting("PRIVATEQUEUE",$user);
			    if ($privatequeue&&$user) {
				$dbc->do("insert into queue (pri,id,played,toplist,user) values ($unauthpri,$songid,0,0,'$privatequeue')") || die;
			    } else {
				$dbc->do("insert into queue (pri,id,played,toplist) values ($unauthpri,$songid,0,0)") || die;
			    }
			}
		    }
		    if ($transforms{$to}) {
			my $res=$dbc->prepare("update ripqueue set fromid = ?, toid = ?, file = ?, songid = ?, status = 0 where id = ?") || die;
			$res->execute($to,$transforms{$to},$newfile,$songid,$id);
		    } elsif ($to eq "mp3") {
			$dbc->do("update ripqueue set fromid = '$to', toid = 'analyse', status = 0 where id = $id") || die;
		    } else {
			$dbc->do("delete from ripqueue where id = $id") || die;
		    }
		} else {
		    print "Conversion discarded\n";
		    $dbc->do("delete from ripqueue where id = $id") || die;
		}
		$dbc->disconnect;
		undef $sel;
		undef $volmnt;
		$dbh->disconnect;
		exit 0;
	    }
	}
    }
    sleep(10); # Interrupted by SIGCHLD
}
