# ====================================================================
# Copyright (c) 1999 GlobeCom GCAB AB.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer. 
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#
# 3. All advertising materials mentioning features or use of this
#    software must display the following acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# 4. The names "GlobeCom Jukebox" and "GlobeCom" must not be used to
#    endorse or promote products derived from this software without
#    prior written permission. For written permission, please contact
#    hpj@globecom.net.
#
# 5. Products derived from this software may not be called "GlobeCom
#    Jukebox" nor may "GlobeCom" appear in their names without prior written
#    permission of the GlobeCom GCAB AB.
#
# 6. Redistributions of any form whatsoever must retain the following
#    acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# THIS SOFTWARE IS PROVIDED BY GLOBECOM GCAB AB ``AS IS'' AND ANY
# EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL GLOBECOM GCAB AB OR
# ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
# ====================================================================

use defsjukebox; # Get the settings entered by the user during configuration

exit
    if (!$PARANOIA||@ARGV!=3);

my ($ignore,$track,$file)=@ARGV;

sub died {
    wait;
    if ($?) {
	my $exit=($?>>8);
	my $signal=($?&0xff);
	print STDERR "Something went wrong converting (Exit code $exit, signal $signal)\n";
	exit 1;
    }
    print "$file\n";
    exit 0;
}

use Fcntl ':flock';

$SIG{CHLD}=\&died;

$|=1;

my ($dir)=($file=~/^(.*)\/[^\/]+/);

if (defined $dir && length($dir) && ! -d $dir) {
    system("mkdir",$dir);
}

open(CDROM,"<".$ENV{CDROM}) || die "Can't open cdrom";
flock(CDROM,LOCK_EX) || die $!;

open(INPUT,"-|") || do {
    open (STDERR,">&STDOUT") || die "Can't dup stdout to err";
    exec ($PARANOIA,"-d",$ENV{CDROM},$track,$file) || die "Couldn't rip $track to $file";
};

while(<INPUT>) {
    if (/\[(\d+):(\d\d)\.\d\d\]/&&$1*60+$2>0) {
	my $length=($1*60+$2)*441*2*2;

	my $lsize=$length;
	while (1) {
	    sleep (5);
	    my @stat=stat($file);
	    my $size=int($stat[7]/$length);
	    if ($lsize!=$size) {
		print $size."%\n";
		$lsize=$size;
	    }
	}
    }
    print;
}
close(CDROM);

# See SIGCHLD handler
exit 1;
