<?
# ====================================================================
# Copyright (c) 1999 GlobeCom GCAB AB.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer. 
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#
# 3. All advertising materials mentioning features or use of this
#    software must display the following acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# 4. The names "GlobeCom Jukebox" and "GlobeCom" must not be used to
#    endorse or promote products derived from this software without
#    prior written permission. For written permission, please contact
#    hpj@globecom.net.
#
# 5. Products derived from this software may not be called "GlobeCom
#    Jukebox" nor may "GlobeCom" appear in their names without prior written
#    permission of the GlobeCom GCAB AB.
#
# 6. Redistributions of any form whatsoever must retain the following
#    acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# THIS SOFTWARE IS PROVIDED BY GLOBECOM GCAB AB ``AS IS'' AND ANY
# EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL GLOBECOM GCAB AB OR
# ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
# ====================================================================

if (!$CONNECTED) {
    include "connect.php3";
}

if ($MUSICUSER) {
    if ($onlydown)
        $auth=2;
    else
        $auth=1;
} else
    $auth=0;

$topk=pow(fetchSetting("TOPLISTK"),1.0/7.0);
if (!$topk)
    $topk=1.2;

function toplist()
{
    global $topk;
    return pow($topk,((time()-902940490)/86400));
}

$dispFormat=fetchSetting("PLAYINGDISPLAYFORMAT");
$queueFormat=fetchSetting("QUEUEDISPLAYFORMAT");
$streamName=fetchSetting("DOWNLOAD");

function defaultQueueEntry($data,$color="")
{
    global $dispFormat;
    global $queueFormat;
    global $lastid;
    global $lastpri;
    global $MUSICPRI;
    global $streamName;
    global $sid;
    global $pri;
    global $auth;
    global $id;

    $title=$data["TITLE"];
    $artist=$data["ARTIST"];
    if ($title) {
	$tit="$artist - $title";
    } else {
	$tit=$artist;
    }

    if ($id&&$pri>=$MUSICPRI)
	$formatstring = $queueFormat;
    else
        $formatstring = $dispFormat;

    $songlen=$data["LENGTH"];
    if($songlen) {
	if ($songlen>=3600)
	    $duration=sprintf("%d:%02d:%02d",$songlen/3600,($songlen/60)%60,$songlen%60);
	else
	    $duration=sprintf("%d:%02d",$songlen/60,$songlen%60);
    } else
	$duration = "?:??";

    $fnam=ereg_replace("[^a-zA-Z-]+","_",$tit);
    $safeName=ereg_replace("'","\\x27",$tit);
    $safeName=ereg_replace("\"","\\x22",$safeName);

    if ($color) {
        $addurl="<A HREF=action.php3?SEL=$sid&LID=$lastid onMouseOver=\"self.status='$safeName'\"><font color=\"$color\">";
    } else {
        $addurl="<A HREF=action.php3?SEL=$sid&LID=$lastid onMouseOver=\"self.status='$safeName'\"><font>";
    }
    $adminurl="<A HREF=addform.php3?OLDID=$sid onMouseOver=\"self.status='Modify $safeName'\" target=\"r\">";
    $streamurl="<A HREF=action.php3/$fnam.mp3?STREAM=$sid onMouseOver=\"self.status='Stream $safeName'\">";
    $endlink="</font></A>";
    $downloadurl="<A HREF=action.php3/$fnam.mp3?$streamName=$sid onMouseOver=\"self.status='Download $safeName'\">";

    $dellink="";
    $prilink="";
    $uplink="";
    if($auth == 1)
    {
        if ($id&&$pri>=$MUSICPRI)
            $delurl="<A HREF=action.php3?REMOVE=$id&LID=$lastid onMouseOver=\"self.status='Remove from queue'\"><FONT COLOR=".warningColor()." SIZE=-2>";
        if ($id&&$pri>$MUSICPRI)
            $priurl="<A HREF=action.php3?PRI=$id&LID=$lastid onMouseOver=\"self.status='Move to front of queue'\"><FONT COLOR=".alternateColor()." SIZE=-2>";
        if ($lastpri>=$MUSICPRI)
            $upurl="<A HREF=action.php3?UP=$id&LID=$lastid onMouseOver=\"self.status='Move up in queue'\"><FONT COLOR=".alternateColor()." SIZE=-2>";
	if ($delurl)
	    $dellink=$delurl."del</FONT></A> ";
	if ($priurl)
	    $prilink=$priurl."pri</FONT></A> ";
	if ($upurl)
	    $uplink=$upurl."up</FONT></A> ";
    }

    $tit = ereg_replace("%t", $tit, $formatstring);
    $tit = ereg_replace("%s", $title, $tit);
    $tit = ereg_replace("%l", $data["ALBUM"], $tit);
    $tit = ereg_replace("%g", $data["TRACKNO"], $tit);
    $tit = ereg_replace("%a", $data["ARTIST"], $tit);
    $tit = ereg_replace("%d", $duration, $tit);
    $tit = ereg_replace("%f", $data["FILE"], $tit);
    $tit = ereg_replace("%p", $data["PLAYED"], $tit);
    $tit = ereg_replace("%v", $data["VOTED"], $tit);
    $tit = ereg_replace("%e", $data["ENTERED"], $tit);

    $tit = ereg_replace("%b", $data["USER"], $tit);
    $tit = ereg_replace("%y", $data["LASTPLAYED"], $tit);
    $tit = ereg_replace("%c", $data["CATEGORY"], $tit);
    $tit = ereg_replace("%o", $data["TOPLIST"], $tit);

    if ($auth == 0 || ($auth==2&&$sid<0)) {
        $tit = ereg_replace("%<A","",$tit);
        $tit = ereg_replace("%<m","",$tit);
        $tit = ereg_replace("%<o","",$tit);
        $tit = ereg_replace("%<n","",$tit);
        $tit = ereg_replace("%<r","",$tit);
        $tit = ereg_replace("%<x[^%>]+%>","",$tit);
        $tit = ereg_replace("%<u[^%>]+%>","",$tit);
        $tit = ereg_replace("%<r[^%>]+%>","",$tit);
        $tit = ereg_replace("%>","",$tit);
        $tit = ereg_replace("%m", "", $tit);
        $tit = ereg_replace("%o", "", $tit);
        $tit = ereg_replace("%n", "", $tit);
        $tit = ereg_replace("%x", "", $tit);
        $tit = ereg_replace("%u", "", $tit);
        $tit = ereg_replace("%r", "", $tit);
    } else {
	$tit = ereg_replace("%<A",$addurl,$tit);
        $tit = ereg_replace("%<m",$streamurl,$tit);
        $tit = ereg_replace("%<o",$downloadurl,$tit);
        $tit = ereg_replace("%<n",$adminurl,$tit);
	if ($delurl)
            $tit = ereg_replace("%<x",$delurl, $tit);
	else
	    $tit = ereg_replace("%<x[^%>]+%>","",$tit);
	if ($upurl)
            $tit = ereg_replace("%<u",$upurl, $tit);
	else
	    $tit = ereg_replace("%<u[^%>]+%>","",$tit);
	if ($priurl)
            $tit = ereg_replace("%<r",$priurl, $tit);
	else
	    $tit = ereg_replace("%<r[^%>]+%>","",$tit);
        $tit = ereg_replace("%>",$endlink,$tit);
        $tit = ereg_replace("%A", $addurl."Add".$endlink, $tit);
        $tit = ereg_replace("%m", $streamurl."Stream".$endlink, $tit);
        $tit = ereg_replace("%o", $downloadurl."Download".$endlink, $tit);
        $tit = ereg_replace("%n", $adminurl."Admin".$endlink, $tit);
        $tit = ereg_replace("%x", $dellink, $tit);
        $tit = ereg_replace("%u", $uplink, $tit);
        $tit = ereg_replace("%r", $prilink, $tit);
    }

    if ($auth==0)  # Unauthenticated
	print "<A HREF=action.php3?SEL=$sid&LID=$lastid onMouseOver=\"self.status='$safeName'\">$tit</A><BR>\n";
    else {
	print "$tit<BR>\n";
    }
    $lastid=$id;
    $lastpri=$pri;
}

if ($time=(int)fetchSetting("REFRESH"))
    print "<META http-equiv=\"Refresh\" content=\"$time;URL=left.php3\">\n";
?>
<HTML>
<HEAD>
<?
head("left");
?>
</HEAD>
<?

$limit=fetchSetting("DEFLIMIT");
if ($limit=="unlimited")
    $limit=20;

logo(fetchSetting("SONGLEN"),min(fetchSetting("SONGPOS"),60));

if($MUSICUSER) {
    if (!$onlydown) {
	if (strlen($VOLUME_x))
	    $vol=$VOLUME_x;
	else {
	    $vs=fsockopen("localhost",1339);
	    fputs($vs," value\n");
	    $vol=fgets($vs,10);
	    fclose($vs);
	}
    }
}

body("left");

$allowstream=(fetchSetting("CURRENT")||(fetchSetting("ICEIP")&&fetchSetting("ICEPORT")));
remote($auth,$vol,$allowstream);

beforeQueue();
$privqueue=fetchSetting("PRIVATEQUEUE");
if ($privqueue)
    $extra="a.user = '$privqueue'";
else 
    $extra="a.user IS NULL";

if (!fetchSetting("PRESELSHOW")) {
    $prepri=fetchSetting("PRESELPRI");
    $result=mysql_query("select a.queueid,a.pri,a.id,b.artist,b.volume,b.title,b.length,b.played,b.voted,b.file,".
			"DATE_FORMAT(b.entered,'%d/%m %H:%i'),b.user,DATE_FORMAT(b.lastplayed,'%d/%m %H:%i'),b.toplist,b.trackno ".
			"from queue a left join songs b on a.id = b.id where pri < $prepri and $extra order by a.pri, a.queueid");
} else {
    $result=mysql_query("select a.queueid,a.pri,a.id,b.artist,b.volume,b.title,b.length,b.played,b.voted,b.file,".
			"DATE_FORMAT(b.entered,'%d/%m %H:%i'),b.user,DATE_FORMAT(b.lastplayed,'%d/%m %H:%i'),b.toplist,b.trackno ".
			"from queue a left join songs b on a.id = b.id WHERE $extra order by a.pri, a.queueid");
}

while(list($id,$pri,$sid,$artist,$album,$title,$length,$played,$voted,$file,$entered,$user,$lastplay,$toplist,$trackno)=mysql_fetch_array($result)) {
    print "<A NAME=$id>";

    if ($sid<0)
	$artist="CD Track ".(-$sid);

    $data["ARTIST"]=$artist;
    $data["ALBUM"]=$album;
    $data["TITLE"]=$title;
    $data["LENGTH"]=$length;
    $data["PLAYED"]=$played;
    $data["VOTED"]=$voted;
    $data["FILE"]=$file;
    $data["ENTERED"]=$entered;
    $data["USER"]=$user;
    $data["LASTPLAY"]=$lastplay;
    $data["TOPLIST"]=$toplist;
    $data["TRACKNO"]=$trackno;

    queueEntry($auth,$id,$sid,$pri,$data);
    $tlen+=$length;
}

afterQueue($tlen);

if ($MUSICUSER)
    helpLink("control");
else
    helpLink("login");
?>
</FONT>
</BODY>
</HTML>
